clear
beep off;

%load data
addpath('..\functions');
fname='..\data\benchmark_data_extended_nodebt_levels'; %artificial data
load(fname);
data=data0;

N=cols(data);

REPS = 21000; %reps
BURN = 1000; %burn-in
SKIP=2;   %skipped draws
Update=1;
idx=BURN+1:SKIP:REPS;
fsize=length(idx);
irun=1;  %irun=1 to estimate initial values (has to be run with irun=1 once and then initial values saved)
npart=20; %number of particles
L=4;    %lag length
LH=0;     %lags of volatility in mean. Fixed in this version to contemporaneous value only
CHECK=1;  %1 to keep VAR coefficients stable
id=unique(index);
NN=length(id);% size of the panel
NA0=(N*(N-1))/2;
horizon=40;  %IRF horizon (linear)
maxtrys=100;
trend=1;   %time trend
qtrend=0;  %quadratic trend
qdummies=0; %quarterly dummies
fe=1;
te=1;
%prepare data
[Y0,X0]=preparexxt(data,L,index,[],[],[],trend,qtrend,...
    qdummies,fe,te,year);
tmpdat=packr([Y0 X0 index year]);



Y=tmpdat(:,1:N);
X=tmpdat(:,N+1:end-2);
rid=sum(X)==0;
X(:,rid)=[];
index=tmpdat(:,end-1);
index1=normalise(index);
year=tmpdat(:,end);
id=unique(index);
EX=(cols(X)-(N*L))+(N*(LH+1));
NN=length(id);
index2=getindex21(index,year);

%priors for VAR coefficients
%priors
lamdaP=0.1;% tightness of prior on lags inf=no prior
tauP=10*lamdaP; %tightness of prior on sum of coefficients
epsilonP=1/1000; %tightness of prior on exogenous
[yd,xd,B0,S0,S,Tstar]=getdummiestrendP(lamdaP,tauP,epsilonP,Y,L,EX,X(:,1:N));

%Exponential prior for degrees of freedom
v0=20;

%priors for covariance
b0=X\Y;
e0=Y-X*b0;
sigmax0=(e0'*e0)/(rows(e0)-cols(X));
%prior for A matrix in sigma=inv(A)*diag(H)*inv(A)'
c0=chol(sigmax0);
iamat=(c0./repmat(diag(c0),1,N))';
c0=inv(c0./repmat(diag(c0),1,N))'; %A matrix based on training sample
epsilon=e0*c0; %starting values for orthogonolised resids
p00_a=1;  %prior variances scaling factor


%starting vaules for svol
if irun==1
h0=cell(NN,1);
Qbig=cell(NN,1);
Fbig=cell(NN,1);
parfor j=1:length(id)
    sel=index==id(j);
    dat=Y(sel,:);
    [outhi,outfi,outgi]=getinitialvol_1(dat,2000,400,10,1);
    h0{j}=outhi;
    Qbig{j}=outgi;
    Fbig{j}=outfi;
end
h0=stackdata(h0);
Qbig=stackdata(Qbig);
Fbig=stackdata(Fbig);

save('initial','h0','Qbig','Fbig')
else
    load initial
end
Qbig0=mean(Qbig);
NT=rows(Y);
hlast=zeros(NT,N*(LH+1));
hlast(:,1:N)=h0;
i=1;
for j=N+1:N:cols(hlast)
hlag=plag1(h0,index,i);
hlast(:,j:j+N-1)=hlag;
i=i+1;
end
hnew=hlast;
NS=cols(hlast);
% mu0=(diag(sigmax0))';
% for j=1:LH
% mu0=[mu0 (diag(sigmax0))'];  %ln(H0)~N(mu0,s0)
% end
mu0=cell(NN,1);
for j=1:NN
    sel=index==id(j);
    tmp=hlast(sel,:);
    mu0{j}=tmp(1,:);
end
    

xvar=[X(:,1:N*L) log(hlast(:,1:N*(LH+1))) X(:,N*L+1:end)];
xfix=log(hlast);
varcoef=xvar\Y;
beta2=vec(xvar\Y);
beta20=beta2;
%priors for transition equation
   FE=[];
    for j=1:length(id)
        dummy=index==id(j);
        FE=[FE dummy];
    end
Yv=log(hlast(:,1:N));
Xv=plag(Yv,index,1);
tmp=packr([Yv Xv FE]);
Yv=tmp(:,1:N);
Xv=tmp(:,N+1:end);
EXv=cols(FE);
%priors
lamdaV=0.1;% tightness of prior on lags inf=no prior
tauV=10*lamdaV; %tightness of prior on sum of coefficients
epsilonV=1; %tightness of prior on exogenous
[ydv,xdv,B0v,S0v,Sv,Tstarv]=...
    getdummiestrendP(lamdaV,tauV,epsilonV,Yv,1,EXv,Xv(:,1:N));
vg0=N+1;             %prior df
g0=diag(diag(Qbig0)*vg0);  %prior scale paramter for Q[i]~IG(g0,vg0)
betaf1=Xv\Yv;
betaf0=vec(betaf1);
betaf2=cell(NN,1);
for j=1:NN
    tmp=betaf1(N+j,:);
    betaf2{j}=tmp;
end
ev=Yv-Xv*betaf1;
Qbig=cov(ev);
residuals=e0;
Ybig=unstackdata(Y,index);
Xbig=unstackdata(X,index);
xfixbig=unstackdata(xfix,index);

dof=20*ones(1,N); %starting values for dof
scale=ones(1,N)*0.1; %scaling parameter for RW metropolis step for each epsilon

dofold=dof;
naccept=zeros(1,N);



save priors10
%storage
hlastsave=zeros(fsize,NT,N);
lamsave=zeros(fsize,NT,N);
dofsave=zeros(fsize,N);
bsave=zeros(fsize,N*(N*L+EX));
fsave=zeros(fsize,N*(N+EXv));
qsave=zeros(fsize,N,N);
asave=zeros(fsize,N,N);
irfsave=zeros(fsize,horizon,N+N,N);


igibbs=1;
jgibbs=1;
while jgibbs<=fsize
       % Display progress:
    if mod(igibbs,Update)==0
        fprintf(' Replication %s of %s.\n', ...
            num2str(igibbs), num2str(REPS)) ;
    end
%step 1: Draw lambda    
lamda=zeros(rows(Y),N);
for i=1:N
lamda(:,i)=getlamda( epsilon(:,i),hlast(:,i),dof(i) );
end
lamdabig=unstackdata(lamda,index);


%step2: Draw DOF
dofnew=zeros(1,N);
nacceptout=zeros(1,N);
for i=1:N
[ dofnew(i),nacceptout(i) ] = ...
    drawdof( dofold(i),scale(i),lamda(:,i),rows(lamda),v0 );
end
dofold=dofnew;
dof=dofold;
naccept=naccept+nacceptout;
arate=naccept./igibbs;

if igibbs>100 && igibbs<1000
for aa=1:length(arate)
    if arate(aa)<0.35
        scale(aa)=scale(aa).*0.99;
    end
    if arate(aa)>0.55
        scale(aa)=scale(aa).*1.01;
    end
end
end  



% %Gibbs step 3:svol
parfor j=1:NN
xfixi=xfixbig{j};
lami=lamdabig{j};
Fmat=zeros(NS,NS);
Fmat(N+1:NS,1:NS-N)=eye(NS-N);
Fmat(1:N,1:N)=betaf1(1:N,:)';
fit=betaf2{j};
Qmat=zeros(NS,NS);
Qmat(1:N,1:N)=Qbig;
iQmat=zeros(NS,NS);
iQmat(1:N,1:N)=invpd(Qbig);
cQmat=zeros(NS,NS);
cQmat(1:N,1:N)=chol(Qbig);

y=Ybig{j};
x=Xbig{j};

%Sample volatility via particle Gibbs step
[betax,BB,Wx,problem]=pftest3F_3(Fmat,fit,cQmat,iQmat,iamat,xfixi,y,x,npart,NS,log(mu0{j}),varcoef,N,LH,L,lami);
indexpf=find(rand(1) < cumsum(Wx(:,end)),1,'first');%discretesample(Wx(:,end),1);
xfixi=betax(:,:,indexpf);
xfixbig{j}=xfixi;
end
xfix=stackdata(xfixbig);
hlast=exp(xfix);
%hlast=exp(hlast1);
xvar=[X(:,1:N*L) log(hlast(:,1:N*(LH+1))) X(:,N*L+1:end)];

%Gibbs step 3: Sample Transition equation parameters
Yv=log(hlast(:,1:N));
Xv=plag(Yv,index,1);
tmp=packr([Yv Xv FE]);
Yv=tmp(:,1:N);
Xv=tmp(:,N+1:end);
Yv0=[Yv;ydv];
Xv0=[Xv;xdv];
mstarv=vec(Xv0\Yv0);  
xx=Xv0'*Xv0;
ixx=xx\eye(cols(xx));  %inv(X0'X0) to be used later in the Gibbs sampling algorithm
[ betaf,PROBLEMf] = getcoefxx( mstarv,Qbig,ixx,maxtrys,N,1,EXv );
if PROBLEMf
betaf=betaf0;
else
betaf0=betaf;
end
 betaf1=reshape(betaf,N+EXv,N);
for j=1:NN
    tmp=betaf1(N+j,:);
    betaf2{j}=tmp;
end
%sample Qbig~variance of shocks to transition eq
resv=Yv-Xv*betaf1;
scalev=resv'*resv+diag(g0);
Qbig=iwishrnd(scalev,(rows(Yv)-cols(Xv))+vg0);

%step 4: Sample VAR coefficients
xvarbigt=unstackdata(xvar,year);
Ybigt=unstackdata(Y,year);
hbigt=unstackdata(hlast(:,1:N).*(1./lamda),year);
[beta11,p11]=...
carterkohnvar_unbal(Ybigt,xvarbigt,...
0,B0',S0,N,year,hbigt,iamat,NN);
% 
% %sample from posterior
[ beta2,PROBLEM] = getcoefxxx( beta11',p11,maxtrys,N,L,EX);
    if PROBLEM
        beta2=beta20;
    else
        beta20=beta2;
    end

varcoef=reshape(beta2,N*L+EX,N);
residuals=Y-xvar*varcoef;


%amat
[iamat,amat]=getamat_new_T(residuals,hlast(:,1:N),lamda,c0,p00_a,N);
epsilon=residuals*amat';


 if igibbs>BURN 
     
  if sum(igibbs==idx)>0
      for j=1:N
    shock=zeros(1,N);
    shock(j)=1;
    irf1=getvolirfFx_0( L,LH,0,N,horizon,shock,[betaf1(1:N,:);zeros(1,N)],...
        Qbig,[varcoef(1:N*L+N*(LH+1),:);zeros(1,N)] );
     irf2=getlevelirfFx_0( L,LH,0,N,horizon,shock,[betaf1(1:N,:);zeros(1,N)],...
        Qbig,[varcoef(1:N*L+N*(LH+1),:);zeros(1,N)] ,iamat');
   irfsave1(jgibbs,:,:,j)=irf1;
   irfsave2(jgibbs,:,:,j)=irf2;
      end
    
    hlastsave(jgibbs,:,:)=hlast(:,1:N);%=zeros(fsize,NT,N);
bsave(jgibbs,:)=beta2;%=zeros(fsize,N*(N*L+EX));
fsave(jgibbs,:)=betaf;%=zeros(fsize,N*(N+1));
qsave(jgibbs,:,:)=Qbig;%=zeros(fsize,N,N);
asave(jgibbs,:,:)=iamat;%=zeros(fsize,NA0);
lamsave(jgibbs,:,:)=lamda;
dofsave(jgibbs,:)=dof;
    
     jgibbs=jgibbs+1;
  end
 end
    igibbs=igibbs+1;
end
     
tmp1=prctile(irfsave1,[50 16 84]);
tmp2=prctile(irfsave2,[50 16 84]);

hlastm=prctile(hlastsave,[50 16 84]);

save('results','tmp1','hlastm','bsave','tmp2','fsave','hlastsave','qsave','asave','lamsave','dofsave');