clear
beep off;

%load data
addpath('..\functions');
%[vec(G) vec(Y) vec(DEF)  vec(R)  vec(REV)]

names{1}='Government spending';
names{2}='GDP';
names{3}='GDP deflator';
names{4}='Real interest rate';
names{5}='Tax revenue';
names{6}='svolG';
names{7}='svolY';
names{8}='svolP';
names{9}='svolR';
names{10}='svolT';

snames{1}='Government spending shock';
snames{2}='Monetary Policy shock';
snames{3}='Tax shock';
snames{4}='Government spending unc. shock';
snames{5}='Monetary Policy unc. shock';
snames{6}='Tax unc. shock';

snames1{1}='Government spending unc. shock';
snames1{2}='Monetary Policy unc. shock';
snames1{3}='Tax unc. shock';


load('priors10');
load('cf_results');

HH=(0:horizon-1)';
pp=[50 16 84];
tmp1=prctile(xout1,pp);
tmp11=prctile(xout3,50);
tmp12=prctile(xout4,50);

tmp2=prctile(zout3,pp);


figure(1)
h1=plotx99(TT,tmp1','r','r',1)
hold on
h2=plot(TT,tmp11','k-','LineWidth',2)
hold on
h3=plot(TT,tmp12','b+','LineWidth',2)
xlim([2000 2020]);
legend([h1 h2 h3 ],{'no fiscal unc','no G unc','no T unc'},'location','northwest');
title('Actual minus counterfactual GDP growth')



figure(2)
h1=plotx99(TT,tmp2','r','r',1)
xlim([2000 2020]);
legend(h1,{'no MP unc'},'location','northwest');
title('Actual minus counterfactual GDP growth')


% x0=50;
% y0=1000;
% width=1500;
% height=700;
% set(gcf,'position',[x0,y0,width,height])

