function [beta11,p11]=...
carterkohnvar_H2(Ybig,Xbig,...
Q,beta0,P00,N,index1,year,hlast,iamatbig)
yearu=unique(year);
T=rows(yearu);
%%Step 2a Set up matrices for the Kalman Filter

ns=cols(beta0);

beta11=beta0;
p11=P00;

% %%%%%%%%%%%Step 2b run Kalman Filter

for i=1:T
    year_i=yearu(i);
    sel=year==year_i;
    id=unique(index1(sel,:));
    NNi=sum(sel); %cross section in year i
    yy=Ybig(sel,:);
    xx=Xbig(sel,:);
    hh=hlast(sel,:);
    iamat=iamatbig(:,:,id);
   %form x matrix
   x=zeros(NNi*N,ns);
   y=zeros(NNi*N,1);
   R=zeros(NNi*N,NNi*N);
   jj=1;
   for j=1:NNi
   r=iamat(:,:,j)*diag(hh(j,:))*iamat(:,:,j)';
   xtmp=kron(eye(N),xx(j,:));
   x(jj:jj+N-1,:)=xtmp;
   R(jj:jj+N-1,jj:jj+N-1)=r;
   
   y(jj:jj+N-1,:)=yy(j,:)';
   jj=jj+N;
   end

    %Prediction
beta10=beta11;
p10=p11+Q;
yhat=(x*(beta10)')';                                              
eta=y'-yhat;
feta=(x*p10*x')+R;
%updating
K=(p10*x')*invpd(feta);
beta11=(beta10'+K*eta')';
p11=p10-K*(x*p10);

end



