function [a, X_new] = cis_as1(w, x, X, xp, A,iQ,Nx,dQ)
% Gaussian model collapse
% w = weights at t-1 [1 N]
% x = particles at t-1 [nx N]
% X = reference trajectory (collapsed) [1 ell]
% xp = reference particle (non-collapsed), [nx 1]

% Extract the model
[nx,N] = size(x);

% Simulate X from p(X|X_t-1, X_{t+ell})
%if(ell == nx-1) % Deterministic setting
    Pxx = 0;
    x_now = x;
    for(t = 1:nx) % Collapse over 1...ell, p(x_{t+\ell} | x_{t-1})
        densx=zeros(1,N);
        for j=1:N
        x_pred = A(1:Nx,:)*x_now(:,j);
        densx(j)=multivariatenormal_1(xp(t,:)',x_pred,iQ,dQ);     
        end
        Pxx = Pxx + densx;%loggausspdf2(xp(t)-x_pred, 1/Q(1,1));
        x_now = [repmat(xp(t,:)',1,N);x_now(1:end-Nx,:)];
    end
    
    X_new = X;

    % Ancestor sampling
    Wght = exp(Pxx-max(Pxx));
    Wght = Wght.*w';
    Wght = Wght/sum(Wght);
    a = find(rand(1) < cumsum(Wght), 1,'first');