function [a, X_new] = cis_as3x(w, x, X, xp, yy,xx,model)
% Gaussian model collapse
% w = weights at t-1 [1 N]
% x = particles at t-1 [nx N]
% X = reference trajectory (collapsed) [1 ell]
% xp = reference particle (non-collapsed), [nx 1]

% Extract the model
A = model.A;
iA=model.iA;
mu=model.mu;
Q = model.Q;
M=model.Nx;
L=model.L;
ell = size(X,1);
[nx,N] = size(x);


    x_filt = zeros(nx, N, ell); % We collapse over ell steps
    P_filt = zeros(nx, nx, ell);
    x_filt(:,:,1) = A*x+mu';
    P_filt(:,:,1) = Q;
    
    % Pure prediction forward
    if ell>1
    for(t = 2:ell)
        x_filt(:,:,t) = A*x_filt(:,:,t-1)+mu';
        P_filt(:,:,t) = A*P_filt(:,:,t-1)*A' + Q;
    end
    end
    % Condition on xp (if this is available)
    C = A;
    R = Q;
%     xp1=(xp(end:-1:1,1:M));
%     xp1=vecr(xp1(1:M,:));
xp1=xp(end,:)';
    innovation = bsxfun(@minus, xp1, mu'+C*x_filt(:,:,ell));
    S = C * P_filt(:,:,ell) * C' + R;
    K = (P_filt(:,:,ell) * C') / S;
    x_filt(:,:,ell) = x_filt(:,:,ell) + K*innovation;
%     P_filt(:,:,ell) = P_filt(:,:,ell) - K*C*P_filt(:,:,ell);
    % Likelihood
    Pxx = loggausspdf2(innovation, S); %p(x'_t+ell\x_t-1)
    
    gxy=zeros(1,N); %g(ys\xs) s=t:t+ell-1
    for J=1:N
    Rx=iA*diag(exp(x_filt(1:M,J,ell)))*iA';
    xvar=[xx(:,1:M*L) x_filt(1:end,J,ell)' xx(:,M*L+1:end)];
    mn=xvar*model.H;
    gxy(J) = loggausspdf2(yy'-mn',  Rx);
    end
 Pxx=Pxx+gxy;
  % gxy 
    
    
% Ancestor sampling
       Wght = exp(Pxx-max(Pxx));
    Wght = Wght.*w;
    if sum(Wght)==0
    a=N;
    else
    Wght = Wght/sum(Wght);
    a = find(rand(1) < cumsum(Wght), 1,'first');
    end
    X_new=x_filt(:,a);
end



