function [X,ll] = pf_1(y,N,X,ell,model)

T = size(y,1);
nx = model.ds;
M=model.Nx;
A = model.A;
cQ=chol(model.q);
Q=zeros(nx,nx);
Q(1:M,1:M)=model.q;
model.Q=Q;
mu=zeros(1,nx);
mu(:,1:M)=model.fit;
model.mu=mu;
iA=model.iA;
xx=model.xx;
L=model.L;
%
x = zeros(nx, N, T);
a = zeros(1, N, T);
w = zeros(1, N, T);

% Gaussian initial state
x(:,:,1) = mvnrnd( model.b00', model.p00, N)';
x(:,N,1) = X(1,:);%vecr(X(1:M,1:M)); % First nx are the initial state



ll = 0;
for(t = 1:T)
    if(t ~= 1)
        
        %ind = resampling(w(1,:,t-1), resampling_type);
       ind = resampling(w(1,:,t-1));

        
            ind = ind(randperm(N));
            if(t+ell <= T) % Collapsing over X_{t:t+ell-1} --> X(t+nx-1:t+ell-1+nx-1)
                      collapsed_indices = t+ell;
                non_collapsed_indices= t+ell:t+ell+1;
                [ind(N), Xp] =  cis_as3x(w(1,:,t-1), x(:,:,t-1), X(collapsed_indices,:), ...
                    X(non_collapsed_indices,:), y(t,:),xx(t,:),model);
            else
               collapsed_indices = t+ell-1;
                % Not implemented yet, skipping AS
                %[ind(N), Xp] = cis_as(w(1,:,t-1), x(:,:,t-1), X(collapsed_indices), [], model);
                ind(N) = N;
                Xp = X(collapsed_indices,:);
            end
            X(collapsed_indices,:) = Xp;            
        
        a(1,:,t) = ind;      
      
        % Noise only on first M state
        x(:,:,t) = A*x(:,ind,t-1)+mu';
     
        for J=1:N
        x(1:M,J,t) = x(1:M,J,t)' + randn(1,M)*cQ;
        end
        
            x(:,N,t) = X(ell+t,:);
        
    end
    
    % Compute weights 
    log_weights=zeros(1,N);
    for J=1:N
    R=iA*diag(exp(x(1:M,J,t)))*iA';
    xvar=[xx(t,1:M*L) x(1:end,J,t)' xx(t,M*L+1:end)];

    mn=xvar*model.H;
    log_weights(J) = loggausspdf2(y(t,:)'-mn',  R);
    end

    const = max(log_weights);
    weights = exp(log_weights-const);
    ll = ll + const + log(sum(weights)) - log(N);
    weights = weights/sum(weights);
    w(1,:,t) = weights; % Save the weights
end

% Generate an output trajectory (only store the first state!)
X = zeros(T+ell,nx);
ind = catrnd(w(:,:,T));
%ind = (w(:,:,T));
%ind=discretesample(w(:,:,T),N);
for(t = T:-1:2)
    X(t+ell,:) = x(:,ind,t);
    ind = a(1,ind,t);
end
for t=1:2
X(t,:) = x(:,ind,t);
end

