
function [beta,BB,W,problem]=...
    pftest3F_rejuv(F,fit,cQ,iQ,iamat,xfix,y,x,N,NS,B00,B,Nx,LH,L,ell,dQ,P00)
%




T=size(y,1);
problem=zeros(T,1);


beta=zeros(T,NS,N); %will hold filtered state variable
beta(1,:,:)=mvnrnd(B00',P00,N)';%repmat(B00',1,N); %fixed initial condition
BB=zeros(N,T); %ancestor indices 
W=zeros(N,T); %weights
beta(1,:,N)=xfix(1,:);
for t=1:T
   % t
if (t~=1)
    index=discretesample(W(:,t-1),N);
    index=index(randperm(N));
 %AS step
    if (t+ell<=T)
    collapsed_indices = NS+t-1:t+ell+NS-2;
%     t+ell:NS+t+ell-1
    [index(N), Xp] = cis_as1(W(:,t-1),squeeze(beta(t-1,:,:)), ...
        xfix(collapsed_indices,1:Nx),...
        xfix(t+ell:NS+t+ell-1,1:Nx),F,iQ,Nx,dQ);
   % index(N)
    else
        collapsed_indices = NS+t-1:T+NS-1;
        index(N)=N;
        Xp=xfix(collapsed_indices,1:Nx);
      
    end
    xfix(collapsed_indices,1:Nx)=Xp;
    BB(:,t)=index';
    
    betahat=xpred(beta(t-1,:,:),F,fit);
    %draw particles
    for j=1:N
    beta(t,:,j)=(betahat(:,:,index(j)))+randn(1,NS)*cQ;
    end
    %conditioned particle
    beta(t,:,N)=xfix(NS-1+t,:);
end

%compute importance weights
logweights=zeros(1,N);
for j=1:N
beta1=squeeze(beta(t,:,j));
R=iamat*diag(exp(beta1(1:Nx)))*iamat';
iR=invpd(R);
detR=det(R);
if LH==-1
   xvar=x(t,:);
else

xvar=[x(t,1:Nx*L) beta1(1:end) x(t,Nx*L+1:end)];

end

res=y(t,:)-xvar*B;
res2=res*iR*res';
logweights(j)=log((1/sqrt(detR)))+(-0.5*res2);
end
const = max(logweights); % Subtract the maximum value for numerical stability
weights = exp(logweights-const);
W(:,t)=weights./sum(weights);


end


% Generate the trajectories from ancestor indices
index = BB(:,T);
for t = T-1:-1:1
    beta(t,:,:) = beta(t,:,index);
    index = BB(index,t);
end

end


function out= xpred(beta,F,fit)
N=size(beta,3);
NS=size(beta,2);
out=zeros(1,NS,N);
mu=zeros(1,NS);
mu(:,1:cols(fit))=fit;
for j=1:N
 fitx= squeeze(beta(:,:,j))*F'+mu;
 
out(:,:,j)=fitx;
end

end