function plot_irf_comparison(IRFs, HH, labels, var, shock, specs, horizon, addlegend)

% prelims
k = length(specs);
plotHandles = zeros(1,1+k); 
plotLabels  = cell(1,1+k);

% colors:
% CM = jet(k)/1.5; 
CM = jet(k)/1.1; 

hold on

% 90% Fan chart for baseline response:
tmp1 = IRFs.M1.(shock)(:,1:horizon,var)';
plotHandles(1) = plot(HH, tmp1(:,1), 'k--', 'linewidth', 1);
plotLabels{1}  = [labels{1}];
x_plot = [HH, fliplr(HH)];
y_plot = [tmp1(:,4)', flipud(tmp1(:,5))'];
h2     = fill(x_plot, y_plot, 1,'facecolor', [0 0.4 1], 'edgecolor', 'none', 'facealpha', 0.4);

% Central estimates for all alternative specs:
for jj = 1:k
    ii      = specs(jj);
    strn    = strcat('M',num2str(ii));
    yy      = IRFs.(strn).(shock)(1,1:horizon,var)';
    plotHandles(1+jj) = plot(HH', yy, 'Color', CM(jj,:), 'LineWidth', 2, 'LineStyle', '-');
%     plotHandles(1+jj) = plot(HH', yy, 'LineWidth', 2, 'LineStyle', '-');
    plotLabels{1+jj} = [labels{ii}];   
    xticks(HH);
end

plot(HH, zeros(1,length(HH)), 'k-');

hold off

if addlegend
legend(plotHandles, plotLabels, 'Location', 'northeast');
end

end
